<?php
#=
//ce tableau est utilis pour le backup et le restore qui sont des algorithmes
//guids par son contenu (celui du tableau !).
//Les valeurs de l'indice de la premire dimension du tableau sont les tables
//qu'il faut sauver ou restaurer.

//Pour ces tables :
// - 'cle' est la cl primaire autonumber lorsqu'elle existe
// - 'garder' signifie qu'il faudra garder dans un tableau la correspondance
//    entre ancienne et nouvelle cl primaire (le nouvel autonumber).
// - 'etab' indique si etab_id est une cl trangre de la table
// - 'passe1' cls trangres qui se rsolvent en passe 1
// - 'passe2  cls trangres qui se rsolvent en passe 2
// - 'liens' indique les valeurs  stocker ngativement dans le backup ou 
//    convertitr immdiatement lorsque c'est possible.

/*
Donc, en plus de stocker chaque enregistrement il faut prendre 2 dcisions :
1) Si on ne connat pas encore la vritable valeur d'une cl trangre, il faut
        la stocker ngativement dans la base et la traiter en passe 2. Sinon, il
        faut la convertir et stocker sa nouvelle valeur en utilisant le tableau de
        conversion (voir 2))
2) Certaines cls primaires qui sont utilises en cls trangres dans d'autres
        tables doivent tre stokes pour tre utilises en passe 1 si c'est possible
        (3e partie), en passe 2 sinon (2e partie).


*/

$guide=array(
//cas un peu particulier pour l'algorithme, mais il faut bien la stocker !
    'etablissements'
              => array('cle'    => 'etab_id',
                       'garder' => false,
                       'etab'   => false,
                       'passe1' => array(),
                       'passe2' => array()),

//2 tables faciles  stocker.
//classes doit tre stocke au dbut pour la cl trangre de 'eleves'
    'classes' => array('cle'    => 'classe_id',
                       'garder' => true,
                       'etab'   => true,
                       'passe1' => array(),
                       'passe2' => array()),
    'libelles_perso'
              => array('cle'    => '',
                       'garder' => false,
                       'etab'   => true,
                       'passe1' => array(),
                       'passe2' => array()),

//2 tables stockes telles quelles, avec des valeurs ngatives pour les cls trangres
//Ce sont les seules ncessitant une passe 2
    'eleves'  => array('cle'    => 'eleve_id',
                       'garder' => true ,
                       'etab'   => true,
                       'passe1' => array('classe_id'),
                       'passe2' => array('compte_id')),
    'profs'   => array('cle'    => 'prof_id',
                       'garder' => true ,
                       'etab'   => true,
                       'passe1' => array(),
                       'passe2' => array('compte_id')),

//pour ces tables, les nouvelles valeurs des cls trangres sont toutes connues
//(demandes permet de connatre juste avant une cl trangre pour reponses)
    'comptes' => array('cle'    => 'compte_id',
                       'garder' => true ,                     //pour la passe 2
                       'etab'   => true,
                       'passe1' => array('prof_id','eleve_id'),
                       'passe2' => array()),
    'demandes'=> array('cle'    => 'message_id',
                       'garder' => true ,                     //pour la passe 1
                       'etab'   => false,
                       'passe1' => array('eleve_id'),
                       'passe2' => array()),
    'reponses'=> array('cle'    => 'reponse_id',
                       'garder' => false,
                       'etab'   => false,
                       'passe1' => array('message_id','prof_id'),
                       'passe2' => array()),
    'resultats'
                  => array('cle'    => 'resultat_id',
                       'garder' => false,
                       'etab'   => false,
                       'passe1' => array('eleve_id'),
                       'passe2' => array()),
    'lien_profs_rubriques'
              => array('cle'    => '',
                       'garder' => false,
                       'etab'   => false,
                       'passe1' => array('prof_id'),
                       'passe2' => array()),
    'lien_profs_classes'
                      => array('cle'    => '',
                       'garder' => false,
                       'etab'   => false,
                       'passe1' => array('prof_id','classe_id'),
                       'passe2' => array()),
    'lien_eleves_disciplines'
                      => array('cle'    => '',
                       'garder' => false,
                       'etab'   => false,
                       'passe1' => array('eleve_id'),
                       'passe2' => array())
        );

?>