<?php
#=
/*
Copyright 2002-2004, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Acadmie de Bordeaux)

This file is part of GiBii/Melia.
GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/utiljs.php");
include("../backup/guide.inc.php");

@session_start();
recupvars(); //globalise les variables de session mais elles sont inacessibles

//vider un tablissement (sauf la table etablissements)
function delrecords($etab_id) {
//on ne se sert pas des facilits du DELETE de MySQL >= 4.0.0
$res=query("SELECT prof_id FROM profs WHERE etab_id=$etab_id");
while (list($pid)=mysql_fetch_array($res)) {
    query("DELETE FROM reponses WHERE prof_id=$pid");
    query("DELETE FROM lien_profs_classes WHERE prof_id=$pid");
    query("DELETE FROM lien_profs_rubriques WHERE prof_id=$pid");
}
$res=query("SELECT eleve_id FROM eleves WHERE etab_id=$etab_id");
while (list($eid)=mysql_fetch_array($res)) {
    query("DELETE FROM demandes WHERE eleve_id=$eid");
    query("DELETE FROM resultats WHERE eleve_id=$eid");
    query("DELETE FROM lien_eleves_disciplines WHERE eleve_id=$eid");
}
query("DELETE FROM eleves WHERE etab_id=$etab_id");
query("DELETE FROM profs WHERE etab_id=$etab_id");
query("DELETE FROM comptes WHERE etab_id=$etab_id");
query("DELETE FROM classes WHERE etab_id=$etab_id");
}

function choisir() {
global $etab_rne, $HIDEDATA;
$PHP_SELF=_server('PHP_SELF');
print "<hr><p class=\"sous_sous_titre\">Indiquez un fichier de backup (extensions sql, gz et bz2 acceptes)</p>";
print "<br />";
print "<center><FORM method=\"post\" action=\"$PHP_SELF\" enctype=\"multipart/form-data\">\n";
print "<p >\n";
print "Slectionnez le fichier qu'un prcdent backup vous a fourni : ";
print "<input type=\"file\" name=\"fichier\">";
print "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" VALUE=\"4000000\">";
print "<br /><br />\n";
print "<input type='submit' class='coul' name='bouton' value='Restaurer'>\n";
print "</FORM>\n";
print "</p></center>\n";
$rep="$HIDEDATA/$etab_rne/backup/";
$handle=opendir(creertousrep($rep));
$nb=0;
//on ne fait afficher le tableau et son en-tte que s'il n'est pas vide
//do le passage sans affichage
$aff='';
setlocale(LC_TIME, "fr");
while ($file=readdir($handle)) {
    $nomcomplet=$rep.$file;
    if ($file!='.' && $file!='..' && is_file($nomcomplet)) {
        $p=strrpos($file,'.');
        if ($p!==false) $ext=strtolower(substr($file,$p+1));
        else $ext='';
        if ($ext=='sql' || $ext=='gz' || $ext=='bz2') {
            $aff.="<tr><td><a href=\"$PHP_SELF?bouton=1&srvfic=".urlencode($nomcomplet)."\">
                   &nbsp;$file</a></td>\n";
            $stats=stat($nomcomplet);
            $taille=round($stats[7]/1024);
            $date=strftime('%A %d %B %Y  %H:%M:%S',$stats[9]);
            $aff.="<td style=\"text-align=center\"> $taille </td>\n"; //taille en Koctets

            $aff.="<td>&nbsp; $date </td>\n"; //date dernire modif
            $aff.="</tr>\n";
            $nb++;
        }
    }
}

if ($nb>0)
   print "<br /><br />";
   print "<p class=\"sous_sous_titre\">Vous pouvez aussi slectionner un fichier dans la liste
          ci-dessous (fichiers stocks sur le serveur) :</p>";
   print "<table width=\"90%\" border='1' align='center'>\n";
   print "<tr class='rubrique'><td width=\"40%\"> Fichier </td>
          <td width=\"20%\"> Taille (Ko)</td>

          <td > Date </td></tr>\n";
   print $aff;
   print "</table>\n";

}

function erreur($mess) {   //pour le 2e passage
alert($mess);
gohistory(-1);
print "</body></html>";
exit();
}

function chksum_verif($nom) {
global $crlf;
$modele_cs='# checksum=';
$fp=fopen($nom,"r");
if (!$fp) return "impossible d'ouvrir le fichier en lecture (s'il existe !)";
$csfic=0;
$contenu='';
while (!feof($fp) && !$csfic) {
    $ligne=fgets($fp,1024);
    $m=strpos($ligne,$modele_cs);
    if ($m!==0) $contenu.=$ligne;
    else
        $csfic=substr($ligne,$m+strlen($modele_cs));
}
if ($csfic!=crc32($contenu)) return "somme de contrle incorrecte";
return "";
}

function enregistrer() {
global $etab_rne, $HIDEDATA;
$erreur="";
$copies="";
$infosfichier=_files('fichier');
//print_r($infosfichier);print "<br>";
$nom=strtolower($infosfichier['name']);
if (empty($nom)) erreur('Pas de fichier indiqu !');
$type=$infosfichier['type'];
$tmp_name=$infosfichier['tmp_name'];

$cstheorique=substr($nom,0,6);
$csreel=substr(md5_file($tmp_name),0,6);
if ($cstheorique!=$csreel) erreur("Contenu du fichier incorrect : la somme de contrle ne convient pas.");

$size=$infosfichier['size'];
$error=$infosfichier['error'];
if ($tmp_name=='none' || $size==0) erreur("Le fichier n'existe pas ou a une taille nulle ou trop importante.");
if ($error) erreur("Erreur $error pour $nom (tmp_name=$tmp_name)");
$dest="$HIDEDATA/$etab_rne/$nom";
if (!move_uploaded_file($tmp_name,creertousrep($dest))) erreur("Erreur de copie vers $dest.");
return $dest;
}

function decompresser($nomfichier) {
global $etab_id, $etab_rne, $HIDEDATA;
if (ereg("\.(bz2|gz|sql)$" , $nomfichier, $cr)) {
    $restore="$HIDEDATA/$etab_rne/$etab_id".'_'.date('Ymd').'.sql';
    switch ($cr[1]) {
        case 'bz2':
             $fbz2=bzopen($nomfichier,'r');
             $fsql=fopen($restore,'w');
             while ($s=bzread($fbz2,10000)) fwrite($fsql,$s);
             fclose($fsql);
             bzclose($fbz2);
             break;
        case 'gz':
             $fgz=gzopen($nomfichier,'r');
             $fsql=fopen($restore,'w');
             while ($s=gzread($fgz,10000)) fwrite($fsql,$s);
             fclose($fsql);
             gzclose($fgz);
             break;
        case 'sql':
             $restore=$nomfichier;
             break;
    }
}
else $restore="";
return $restore;
}

function majforeign($set,&$paramspasse) {
global $eleve_id,$prof_id,$message_id,$classe_id; //tableaux de conversion des cls primaires
//$paramspasse=array('eleve_id','prof_id') ou array('eleve_id') ou... array()
foreach($paramspasse as $nomforeign) {
    //$nomforeign='eleve_id'
    //global $$nomforeign; // globalise le tableau $eleve_id[]
    $cnv=&$$nomforeign; // si $nomforeign='eleve_id', $cnv pointe[] comme $eleve_id[]
    //remplacer par ex. eleve_id=4 par eleve_id=123, o 123=$eleve_id[4]
    $cherche=$nomforeign.'=';
    $set=preg_replace("/$cherche-(\d+)/e","'$cherche'.\$cnv[$1]",$set);  //ouf...
    //print "[[$set";print "<br />";
}
//print $set."<br>";
return $set;
}

function restore_passe1() {
global $guide, $etab_id, $tini,
       $eleve_id,$prof_id,$compte_id,$message_id; //tableaux de conversion des cls primaires
print "<h2>Passe 1 : enregistrement provisoire dans la base</h2>";

//rcuprer la seule ligne de la section [etablissements] (peut-on faire sans le foreach ?)
print "<h3>Table etablissements</h3>";
foreach($tini['etablissements'] as $oldetabid => $set) ;
//Afficher les caractrisqtiques de l'tab du fichier backup
print "<b>Ancien numro</b> : $oldetabid";print "<br /><br />";
$set=urldecode($set);

if ($oldetabid==$etab_id)  {
    //supprimer tous les enregistrements relatifs  etab_id
    //sauf celui de la table etablissements
    delrecords($etab_id);
    }

$sql="UPDATE etablissements SET $set WHERE etab_id=$etab_id";
print $sql;print "<br />";
query($sql);
$numetab=$etab_id;          //le nom 'numetab' est IMPOS par le backup

// partir d'ici, on peut considrer qu'on fait un restore dans un autre site
//Balayer les tables de l'INI
foreach($tini as $table => $contenu) {  //par ex. $table='eleves'  (une section de l'ini)
    if ($table=='etablissements') continue;
    print "<h3>Table $table</h3>";
    $params=$guide[$table];         //par ex. array('cle'   => 'eleve_id',
                                    //                            'garder'=> true ,
    $nomid=$params['cle'];          //par ex. eleve_id
    $garder=$params['garder'];
    $paramspasse1=$params['passe1'];
    if ($params['etab']) $queueinsert=",etab_id=$numetab";
    else $queueinsert="";
    if ($garder) {
        //crer un tableau de conversions
        global $$nomid;                //par ex. global $eleves
        $conv=&$$nomid;                //$t[] pointe la mme chose que $eleve_id[]
        $conv['NULL']='NULL';          //pour le cas de la table comptes et des champs eleve_id et prof_id
    }
    //balayer les lignes de la table
    foreach($contenu as $nid => $ligne) {
        $set=urldecode($ligne);
        $sql="INSERT INTO $table SET ".majforeign($set,$paramspasse1).$queueinsert;
        query($sql);
        print $sql;print "<br />";
        if ($garder) {
           $conv[$nid]=mysql_insert_id();  //pour la conversion ancien->nouveau
           print "&nbsp;&nbsp;&nbsp;-> ${nomid}[$nid]=".$conv[$nid]."<br /><br />";
        }
    }
}
print "<hr>\n";
return $numetab;
}


function restore_passe2($numetab) {
global $tini, $guide, $etab_id,
       $eleve_id,$prof_id,$compte_id,$message_id; //tableaux de conversion des cls primaires
print "<h2>Passe 2 : mise  jour des cls trangres</h2>";
foreach($tini as $table => $contenu) {  //par ex. $table='eleves'
    $params=$guide[$table];             //par ex. array('cle'   => 'eleve_id',
                                        //              'garder'=> true ,
    //dans cette passe, on fait un peu l'hypocrite en faisant comme s'il y avait
    //plusieurs lments dans params['passe2'] et qu'on ne savait pas que $params['etab'] tait vrai
    $paramspasse2=$params['passe2'];
    if (empty($paramspasse2)) continue;
    print "<h3>Table $table</h3>";
    $nomid=$params['cle'];
    $where="";
    $select="";
    foreach($paramspasse2 as $nomforeign) {
            $where.="OR $nomforeign<0 ";
        $select.=",$nomforeign";
    }
    $where='('.substr($where,3).')'; //supprimer le 1 OR
    $select="$nomid,".substr($select,1);                    //supprimer la ,
    if ($params['etab']) $where.=" AND etab_id=$numetab";

    $res=query("SELECT $select FROM $table WHERE $where");
    while ($row=mysql_fetch_array($res)) {
        $valeurid=$row[$nomid];
        $set="";
        //la boucle qui suit est gnrale mais ici, elle n'a qu'un lment !
        foreach($paramspasse2 as $nomforeign) {     //$nomforeign='compte_id'
            $tabcnv=$$nomforeign;                   //$tabcnv[x]===$compte_id[x]
            $set.=",$nomforeign=".$tabcnv[-$row[$nomforeign]];   //$set=",compte_id=$compte_id[-ancienCompte_id]"
        }
        $set=substr($set,1); //enlever la premire virgule
        //ci-dessous par ex. : UPDATE profs SET compte_id=48
        $sql="UPDATE $table SET $set WHERE $nomid=$valeurid";
        print $sql;print "<br />";
        query($sql);
    }
}
print "<hr>\n";
}


//-------------  ppal  -------------------
opensession('Admin',false);
connecte($host,$user,$mdp,$db);
print "<HTML><HEAD><link rel=\"stylesheet\" href=\"../themes/".$etab_theme."/b2i.css\">\n";
print "<title>Backup de la base $db</title></head>\n";
print "<BODY class=\"arialadmin\">\n";
print "<p class='sous_titre'>Restauration de votre tablissement</p>\n";
if (!isset($bouton)) {
    choisir();
}
else {
    if ($bouton==1) $nomrecu=urldecode($srvfic);
    else $nomrecu=enregistrer();
    print "<p style=\"text-align:center\">";
    if ($nomrestore=decompresser($nomrecu)) {
        $tini=parse_ini_file($nomrestore,true);   //global dans les fonctions
        $numetab=restore_passe1();
        restore_passe2($numetab);
        print "<p><b><big>Restauration effectue</big></b>";
        if ($etab_id==$numetab) print "pour l'tablissement $etab_id";
        else print ". L'tablissement a maintenant pour numro : <big><b>$numetab</b></big>";
        print "</p><br />";
    }
    else alert("Le fichier fourni ($nomfichier)\nn'a pas l'extension voulue (sql, bz2 ou gz).");
    retour("../admin/admin_bas.php");
}
print "</body></html>";

?>