<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Acadmie de Bordeaux)

This file is part of Gibii.

Gibii is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gibii is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gibii; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************
*/

include("./util.class.php");

/****************************************************************************/
class qqun {
 var $table;     //celle  laquelle doit appartenir l'individu
 var $champ_id;  //libell que porte la cl primaire dans la table sous jacente (eleve_id, prof_id)
 var $id;        //l'autonumber de la table dont est issu l'objet
 var $nom,$prenom,$dnaiss,$mdp; //mdp est cod par md5
 var $civil,$ident_nat,$tag;
 var $compte_id;
 var $login,$statut;
 var $etab_id;
 var $annee;     //la dernire anne scolaire connue (pour reprer les disparus notamment)
 var $findcount; //nb lignes trouves dans un findfirst
 var $ressource; //prive : pour findfirst, findnext
 var $messages;  //informations et erreurs rencontres pour le nouvel arrivant

function qqun($st) {
//$t est la table  laquelle appartient la personne
$this->statut=ucwords($st);   //Eleve ou Prof
$this->table=$st.'s';         //eleves ou profs
$this->champ_id=$st.'_id';    //eleve_id ou prof_id
$this->login=''; //pourra tre affect si besoin...
$this->civil='';
$this->messages=array();
}

function setcommon($obj) { //partie commune aux descendants
 //$obj vient de eleves, profs ou new_et le champ rcupr de la table
 //s'appelle 'eleve_id' ou 'prof_id', d'o cette criture avec accolades
$this->id =$obj->{$this->champ_id};
$this->ident_nat=$obj->ident_nat;
$this->nom=stripslashes($obj->nom);
$this->prenom=stripslashes($obj->prenom);
$this->dnaiss=$obj->dnaiss;
if (isset($obj->mdp)) $this->mdp=$obj->mdp;
//sinon on s'en fout : l'indiv ne vient pas d'une table new
$this->civil=$obj->civil;
$this->compte_id=$obj->compte_id;
$this->etab_id=$obj->etab_id;
$this->ident_nat=$obj->ident_nat;
$this->tag=$obj->tag;
$this->annee=$obj->annee;
}

function setbyid($id) { //rcupre l'objet de SA table, avec toutes ses donnes utiles
$res=query("select * from $this->table where $this->champ_id=$id;");
$obj=mysql_fetch_object($res);
if ($obj) $this->setbyobj($obj);  //dans les descendants eleve et prof
return $obj;
}


/* 2 niveaux d'erreurs :
    - seterror : l'individu n'est pas pris en compte (mais le script continue)
      du tableau de rsultat
*/
function seterror($cause) {
$this->addmess($cause);
return false; //fait retourner false  la fonction appelante (signal d'erreur)
}

function addmess($contenu) {
$this->messages[]=$contenu;
}

function vider() {  //il s'agit plutt d'une revirginisation de l'objet
//pour viter des mlanges lors de champs absents du suivant
//ne dsaffecte que les champs qui sont sont relatifs  un individu
//donc tous sauf :
$garde=array('table','champ_id','etab_id','annee','findcount','ressource',
             'messages','login','civil','statut');
foreach(get_object_vars($this) as $champ=>$valeur) {
       if (!in_array($champ,$garde,false)) unset($this->$champ);
}
$this->login=''; //pourra tre affect si besoin...
$this->civil='';
$this->messages=array();
}

function delete() { //supprime l'individu associ  l'objet de sa table de dpart
return query("DELETE FROM $this->table WHERE $this->champ_id=$this->id;");
}

function homonymes() {
//recherche les homonymes de $this dans la table $t (nom, prnom et dnaiss)
  $tbl=array();
  $classereelle=get_class($this);
  $vieux=new $classereelle();
  $existe=$vieux->findfirst("lower(nom)=lower('".addslashes($this->nom)."')
                 and lower(prenom)=lower('".addslashes($this->prenom)."')
                 and (tag=0 or tag IS NULL);");    //pas ceux stocks provisoirement
  while($existe) {
      $vieux->dnaiss=normerdate($vieux->dnaiss);
      if (  !empty($this->dnaiss)
         && $this->dnaiss==$vieux->dnaiss
         && ($this->etab_id==$vieux->etab_id  //repasse ou bascule d'un ancien de l'tab
             || $this->annee!=$vieux->annee)  //ancien d'un tab voisin
         )
            {
            //trouv sans ambigut (si, si ! faut pas pousser : nom, prnom, dnaiss)
            $tbl=array();  //supprime les ventuels pseudo-homonyme dj stocks
            $tbl[]=$vieux;
            break;         //on arrte puisqu'on a trouv
      }
      $tbl[]=$vieux;     //engranger tous ceux qui ont mme (nom,prnom)
      $existe=$vieux->findnext();
  }
  $vieux->findclose();
  return $tbl;   //retourne un tableau d'homonymes
}

function findfirst($condition="1") {
  unset($this->ressource);
  $this->ressource=query("select * from $this->table where $condition;");
  $obj=false;
  $this->findcount=0;
  if ($this->ressource) {
      $this->findcount=mysql_num_rows($this->ressource);
      if ($this->findcount) {
          $obj=mysql_fetch_object($this->ressource);
          $this->setbyobj($obj);
      }
  }
  return $obj;
}

function findnext() {
  $obj=false;
  if (isset($this->ressource)) {
      $obj=mysql_fetch_object($this->ressource);
      if ($obj) $this->setbyobj($obj);
      else {
          unset($this->ressource);
          unset($this->findcount);
      }
  }
  return $obj;
}

function findclose() {
  unset($this->ressource);
  unset($this->findcount);
}

function creerloginbase($masque) {    //mthode prive, en principe
//interprter les codes ainsi :
//   n=nom, p=prnom, d=division ou discipline, #=numro, b=naissance (born)
$result='';
$inom=0;$igroup=0;$ipre=0;$idiv=0;$idnaiss=0;
for ($i=0; $i<strlen($masque); $i++) {
     switch ($masque[$i]) {
       case "n" : $result .=carvalide($this->nom,$inom,"");break;
       case "p" : $result .=carvalide($this->prenom,$ipre,"");break;
       case "d" : $result .=carvalide($this->getgroupvalue(),$igroup,_ALPHANUM);break;
       case "b" : $result .=carvalide($this->dnaiss,$idnaiss,_NUM);break;
       case "#" : $result .=carvalide($this->ident_nat,$inum,_NUM);break;
       default  : $result .=$masque[$i];break;
       }
     }
return $result;
}

function creerloginunique($masque) {
//cre le login d'un nouveau en tenant compte d'un ventuel dbut de login propos
//(voir plus bas)
if (!empty($this->login)) {
    //cas d'une nouvelle anne avec $this affect dans la ligne du fichier texte
    $login=$this->login;
}
else $login=$this->creerloginbase($masque);

$loginnew=$login;
$suffixe=0;

//recherche du premier login possible  partir de la "base" contenue dans $login
//(par exemple, $login contient initialement bm ou ben.mar)
do {
   $logintest=$loginnew;        //pour la requte
   $suffixe++;
   $loginnew=$login.$suffixe;   //pour le prochain passage
   //recherche lourde pour viter tout souci...
   $sql="SELECT * FROM comptes
          WHERE login='".addslashes($logintest)."'
            and etab_id=$this->etab_id";
   $result=query($sql);
   }
while (mysql_num_rows($result));
$this->login=$logintest;
return $logintest;
}

function ajoutertable($tag) {
$nomquote=addslashes($this->nom);
$prenomquote=addslashes($this->prenom);
$nomchampgroupe=$this->getgroupfield();
$valeurgroupe=$this->getgroupid();
$res=query("INSERT INTO $this->table SET
                   nom='$nomquote',
                   prenom='$prenomquote',
                   dnaiss='$this->dnaiss',
                   ident_nat='$this->ident_nat',
                   $nomchampgroupe=$valeurgroupe,
                   civil='$this->civil',
                   annee=$this->annee,
                   tag=$tag,
                   etab_id=$this->etab_id;");
$this->id=mysql_insert_id();
return $this->id;
}

function updatetable($id) {//modifie la table sous-jacente
//nom, prenom, dnaiss sont inchangs
$nomchampgroupe=$this->getgroupfield();
$valeurgroupe=$this->getgroupid();
$this->id=$id;
$ret=query("UPDATE $this->table
               SET civil='$this->civil',
                   dnaiss='$this->dnaiss',
                   ident_nat='$this->ident_nat',
                   $nomchampgroupe='$valeurgroupe',
                   etab_id=$this->etab_id,
                   annee=$this->annee,
                   tag=0
             WHERE $this->champ_id=$id");
return $ret;
}

} //classe qqun


/*****************************************************************************/
/*****************************************************************************/

class eleve extends qqun {
 var $classe_id, $divcod;
 var $imp_diplome;
 var $lv;        //tableau des 3 langues vivantes pratiques lv[1]=2 signifie LV1=espagnol
                 //lv[3]=0 signifie : pas de LV3

function eleve() {
parent::qqun('eleve');
$this->lv=array();
}

function setbyobj($obj) {   //$obj est un rsultat de mysql_fetch_array
$this->setcommon($obj);     //affecte id, nom, prenom, dnaiss, GEP_id, tag
$this->classe_id=$obj->classe_id;
$this->imp_diplome=$obj->imp_diplome;
$this->classe_id=$obj->classe_id;
$this->divcod=$this->getgroupvalue();
//langues
$reslv=query("SELECT rang,disc_id FROM lien_eleves_disciplines WHERE eleve_id=$this->id");
while (list($r,$d)=mysql_fetch_array($reslv))
        $this->lv[$r]=$d;
return $obj;
}

function getgroupname()  {return "Classe";}       //pour les affichages
function getgroupfield() {return "classe_id";}
function getgroupid()    {return $this->classe_id;}
function getgroupvalue() {
static $divisions=array(); //n'est calcul et stock qu'une fois
if (empty($divisions)) {
    $res=query("SELECT * FROM classes;");
    while ($obj=mysql_fetch_object($res))
        $divisions[$obj->classe_id]=$obj->divcod;
}
if (isset($this->classe_id) && isset($divisions[$this->classe_id]))
    return $divisions[$this->classe_id];
else return '';
}

function vider() {
parent::vider();
$this->lv=array();
}


function ajouteroptions($tag) {
if ($tag) $signe=-1; else $signe=1; //ajout provisoire ou dfinitif
foreach ($this->lv as $i=>$disc_id) {
   query("INSERT INTO lien_eleves_disciplines
                  SET rang=$i, eleve_id=$signe*$this->id, disc_id=$disc_id");
}
}

function updateoptions($tag) {
query("DELETE FROM lien_eleves_disciplines WHERE eleve_id=$this->id");
$this->ajouteroptions($tag);
}

function insertcompte($champactif) {
$loginquot=addslashes($this->login);
if (!isset($this->mdp)) $this->mdp=md5($this->dnaiss);
$res=query("INSERT INTO comptes SET
                     login='$loginquot', statut='Eleve',
                     mdp='$this->mdp',
                     actif=$champactif,
                     nbsessions=0,
                     eleve_id=$this->id,
                     etab_id=$this->etab_id;"
            );
if ($res) {
    $id=mysql_insert_id();
    query("UPDATE eleves SET compte_id=$id WHERE eleve_id=$this->id");
}
else $id=0;
$this->compte_id=$id;
return $id;
}

function couperficelles() {
//travail effectu avant de supprimer $this de sa table
$id=$this->id;
//supprimer dans l'ordre reponses, demandes
 $resdem=query("SELECT message_id FROM demandes WHERE eleve_id=$id");
 while (list($message_id)=mysql_fetch_array($resdem)) {
     query("DELETE FROM reponses WHERE message_id=$message_id");
 }
 query("DELETE FROM demandes WHERE eleve_id=$id;");
 query("DELETE FROM lien_eleves_disciplines WHERE eleve_id=$id");
//on ne supprime pas le compte mais on le remplace par un compte inaccessible
query("UPDATE comptes SET mdp='a57d7282501f313bbe6d5631bed1e120'
        WHERE eleve_id=$id");
}

//mthode de classe
//tolre un codage personnalis des langues dans le fichier texte
//d'importation et mmorise ce codage dans un tableau
function trouverlangue($code) {
static $precedents=array();
if (is_numeric($code)) return $code;
$code=strtoupper(trim(substr($code,0,2)));
if (isset($precedents[$code])) return $precedents[$code];
$res=query("SELECT disc_id FROM disciplines WHERE code_langue LIKE '$code%'");
if (!list($disc_id)=mysql_fetch_array($res)) {
    $res=query("SELECT disc_id FROM disciplines WHERE libelle LIKE '$code%'");
    if (!list($disc_id)=mysql_fetch_array($res))
        return false; //plus d'espoirs
}
$precedents[$code]=$disc_id;
return $disc_id;
}



//Les champs d'un fichier texte eleves.txt
//****************************************
//[ident_nat], [civil], nom, prenom, [classe], [naissance], [login], [mdp crypt], [lv1[, lv2[, lv3]]]
//mdp est facultatif et, s'il existe, vaut md5(ELENOPRO)

function setbytxt($ligne,$mdpenclair) {
//affecte un objet  partir d'un tableau associatif $ligne
$etab_id=$this->etab_id; //pour simplifier les notations

//ident_nat
//---------
$ident_nat=trim($ligne[0]);
if (!empty($ident_nat)) {
    if (is_int($ident_nat))
        $ident_nat.='_'.$etab_id; //de faon  conserver en tte le n GEP
                                  //et prserver l'unicit entre tous les tabs
}
$this->ident_nat=$ident_nat;

//nom
//---
$nom=ltrim(ASCII2ANSI($ligne[2]));
if ($nom=="")
    return $this->seterror("nom absent");
$this->nom=$nom;

//prnom
//_-----
$this->prenom=$prenom=ltrim(ucwords(strtolower(ASCII2ANSI($ligne[3]))));

//civilit  (fait  cet endroit pour connatre le prnom)
//--------
$civil=ucfirst(strtolower($ligne[1]));
switch ($civil) {
    case 'M.':case 'G':case 'H' : $civil='M.'; break;
    case 'Mme':case 'Me':case 'Mlle':case 'F': $civil='Mlle'; break;
    default : { //on devine le sexe ! Si, si !
         if ($prenom) {
             $fin=substr($prenom,-1);
             if ($fin=='e' || $fin=='a') //critre simplet mais meilleur que 50%
                $civil="Mlle";
             else $civil="M.";
         }
         else $civil="M.";
    }
}
$this->civil=$civil;

//classe
//------
if (empty($ligne[4])) $this->divcod='';
else $this->divcod=$ligne[4];
$handle=query("SELECT classe_id FROM classes
               WHERE divcod='$this->divcod' and etab_id=$etab_id;");
if (mysql_num_rows($handle)==0) {
    query("INSERT INTO classes SET divcod='$this->divcod', etab_id=$etab_id;");
    $classe_id=mysql_insert_id();
}
else list($classe_id)=mysql_fetch_array($handle);
$this->classe_id=$classe_id;

//date de naissance
//-----------------
$this->dnaiss=normerdate($ligne[5]);

//login
//-----
if (!empty($ligne[6])) $this->login=trim($ligne[6]);

//mot de passe
//------------
//s'il existe, le mdp est cod md5 ou pas
if (empty($ligne[7])) {
    $this->mdp=md5($this->dnaiss);  //crypter la date de naissance
}
else {
    if ($mdpenclair)
        $this->mdp=md5($ligne[7]);  //s'il est en clair, il FAUT le crypter ! (c'est ainsi que l'attend la table comptes)
    else $this->mdp=trim($ligne[7]);
}

//langues
//-------
$offset=8; //rang de la langue 1 dans la ligne texte (compt  partir de 0)
$i=1; //il ne peut y avoir "franais L.E." dans le fichier texte
while (!empty($ligne[$offset+$i-1])) {
    $this->lv[$i]=$this->trouverlangue($ligne[$offset+$i-1]);
    $i++;
}
return true;
} //setbytext
} // classe eleve

/*****************************************************************************/
class prof extends qqun {
 var $disc_id, $discipline;
 var $admin;
 var $classes;

function prof() {
parent::qqun('prof');
$this->classes=array(); //dbute  l'indice 1 ; contiendra des classe_id
}

function setbyobj($obj) {   //$obj est un rsultat de mysql_fetch_array
$this->setcommon($obj);
$this->disc_id=$obj->disc_id;
$this->admin=$obj->admin;
$this->discipline=$this->getgroupvalue();
$rescl=query("SELECT classe_id FROM lien_profs_classes WHERE prof_id=$this->id");
$i=1;
while (list($cl_id)=mysql_fetch_array($rescl))
        $this->classes[$i++]=$cl_id;
return $obj;
}

//ces 4 fonctions permettent de traiter de la mme faon la classe d'un lve
//et la discipline d'un prof, sous le nom "groupe", ce qui facilite par
//exemple les requtes (trouver classe/discipline de l'lve/du prof)
//ou les affichages informatifs
function getgroupname()  {return "Discipline";}
function getgroupfield() {return "disc_id";}
function getgroupid()    {return $this->disc_id;}
function getgroupvalue() {
  static $disciplines=array();
  if (empty($disciplines)) {
      $res=query("SELECT * FROM disciplines;");
      while ($obj=mysql_fetch_object($res))
          $disciplines[$obj->disc_id]=$obj->libelle;
  }
  if (isset($this->disc_id) && isset($disciplines[$this->disc_id]))
      return $disciplines[$this->disc_id];
  else return '';
}

function vider() {
parent::vider();
$this->classes=array();
}

function ajouteroptions($tag) {
if ($tag) $signe=-1; else $signe=1; //ajout rel ou incertain
for ($i=1; $i<=count($this->classes); $i++) {
   query("INSERT INTO lien_profs_classes SET prof_id=$signe*$this->id, classe_id=".$this->classes[$i]);
}
}

function updateoptions($tag) {
query("DELETE FROM lien_profs_classes WHERE prof_id=$this->id");
$this->ajouteroptions($tag);
}

function insertcompte($champactif) {
$loginquot=addslashes($this->login);
if (!isset($this->mdp)) $this->mdp=md5($this->dnaiss);
$res= query("INSERT INTO comptes
                SET login='$loginquot',
                    statut='Prof',
                    mdp='$this->mdp',
                    actif=$champactif,
                    nbsessions=0,
                    prof_id=$this->id,
                    etab_id=$this->etab_id;");
if ($res) {
    $id=mysql_insert_id();
    query("UPDATE profs SET compte_id=$id WHERE prof_id=$this->id");
}
else $id=0;
$this->compte_id=$id;
return $id;
}

//cochercomptences : appele seulement pour les profs de Melia
function cochercompetences($niveau) {
//on supprime ce qu'on va ajouter de toute faon ensuite afin de ne pas l'avoir en double
//(c'est plus rapide que d'ajouter un par un dans une boucle aprs vrification)
query("DELETE FROM lien_profs_rubriques WHERE prof_id=$this->id");
//transformer par ex. "niv23" en "brevet_no=2 or brevet_no=3"
$where='';
for ($i=3; $i<strlen($niveau); $i++) $where.="or brevet_no={$niveau[$i]} ";
$where=substr($where,3); //enlve le premier "or"
//si prof_id=213, on ajoute tous les couples de la forme (213,x),
//o x vaut chacune des rubriques couverte par le niveau choisi par l'tablissement
query("INSERT INTO lien_profs_rubriques SELECT DISTINCT $this->id , rub_no
                                          FROM items
                                         WHERE $where");
}

function couperficelles() {
$id=$this->id;
query("DELETE FROM lien_profs_classes WHERE prof_id=$id;");
query("DELETE FROM lien_profs_rubriques WHERE prof_id=$id;");
//on ne supprime pas le compte mais on le remplace par un compte inaccessible
query("UPDATE comptes SET mdp='a57d7282501f313bbe6d5631bed1e120'
        WHERE prof_id=$id;");
//on ne dtruit pas les rponses ventuelles, sauf si on veut une purge annuelle
}

//Les champs d'un fichier texte profs.txt
//***************************************
//ident_nat, civil, nom, prenom, disc, dnaiss, login, mdp, <liste-des-classes>

function setbytxt($ligne,$mdpenclair) {
//affecte un objet  partir d'un tableau associatif $ligne
static $tabclasses=array();
$etab_id=$this->etab_id;
$nbchamps=count($ligne);

//ident_nat
//--------
$ident_nat=trim($ligne[0]);
if (!empty($ident_nat)) {
    if (is_int($ident_nat))
       $ident_nat.='_'.$etab_id; //de faon  conserver en tte le n GEP
                                 //et prserver l'unicit entre tous les tabs
}
$this->ident_nat=$ident_nat;

//civilit
//--------
$civil=ucfirst(strtolower($ligne[1]));
if ($civil!="M." && $civil!="Mlle") $civil="Mme"; //statistiquement vrai...
$this->civil=$civil;

//nom
//---
$this->nom=$nom=ltrim(ASCII2ANSI($ligne[2]));
if ($nom=="")
    return $this->seterror("nom absent");

//prnom
//_-----
$this->prenom=$prenom=ltrim(ucwords(strtolower(ASCII2ANSI($ligne[3]))));

//discipline
//----------
$discco=trim($ligne[4]);
//si inconnue, retourne la valeur par dfaut de la table _params_globaux
list($this->disc_id,$this->discipline)=searchdiscipline($discco);

//date de naissance
//-----------------
$this->dnaiss=$dnaiss=normerdate($ligne[5]);

//login
//-----
$this->login=trim($ligne[6]);

//mot de passe
//------------
//le mdp est vide dans le fichier texte lorsque le fichier texte ne vient pas du GEP
if (empty($ligne[7])) {
    $this->mdp=md5($this->dnaiss);  //crypter la date de naissance
}
else {
    if ($mdpenclair)
        $this->mdp=md5($ligne[7]);  //s'il est en clair, il FAUT le crypter ! (c'est ainsi que l'attend la table comptes)
    else $this->mdp=trim($ligne[7]);
}

//ajouter les classes du prof
//---------------------------
$valuesreq="";
if (count($tabclasses)==0) {
    //rcupre un tableau : $tabclasses["3G3"]=7 par exemple
    $res=query("SELECT * FROM classes WHERE etab_id=$etab_id;");
    while ($row=mysql_fetch_object($res)) $tabclasses[$row->divcod]=$row->classe_id;
}
//les classes dmarrent au rang 8 (en dbutant  0)
$offset=8;
for ($i=$offset; $i<count($ligne); $i++) {
     $rang=$i-$offset+1;
     $classe=$ligne[$i];
     if (isset($tabclasses[$classe])) {
         $classe_id=$tabclasses[$classe];
     }
     else {
         $this->addmess(" classe [$classe] cre. ");
         query("INSERT INTO classes SET divcod='$classe', etab_id=$etab_id;");
         $classe_id=mysql_insert_id();
         $tabclasses[$classe]=$classe_id;
     }
     $this->classes[$rang]=$classe_id;
}
return true;
} //setbytext
} //class
?>