<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Alain Pomirol 
(CATICE Acadmie de Bordeaux)

This file is part of GiBii/Melia.

GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/

include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/utiljs.php");
include("../include/scriptsql.php");


//@session_start();
//recupvars(); //globalise les variables de session mais elles sont inacessibles

function choisir() {
$PHP_SELF=_server('PHP_SELF');
print "<p align='center'>Indiquez un fichier de backup (extensions sql, gz et bz2 acceptes)</p>";
print "<p>&nbsp</p>";
print "<FORM method=\"post\" action=\"$PHP_SELF\" enctype=\"multipart/form-data\">\n";
print "<p align=\"center\">\n";
print "Slectionnez le fichier qu'un prcdent backup vous a fourni : ";
print "<input type=\"file\" name=\"fichier\">";
print "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" VALUE=\"4000000\">";
print "<br /><br />\n";
print "<input type='submit' class='coul' name='bouton' value='Restaurer'>\n";
print "</FORM>\n";
print "</p>\n";
}

function erreur($mess) {   //pour le 2e passage
alert($mess);
gohistory(-1);
print "</body></html>";
exit();
}

function chksum_verif($nom) {
global $crlf;
$modele_cs='# checksum=';
$fp=fopen($nom,"r");
if (!$fp) return "impossible d'ouvrir le fichier en lecture (s'il existe !)";
$csfic=0;
$contenu='';
while (!feof($fp) && !$csfic) {
    $ligne=fgets($fp,1024);
    $m=strpos($ligne,$modele_cs);
    if ($m!==0) $contenu.=$ligne;
    else
        $csfic=substr($ligne,$m+strlen($modele_cs));
}
if (!$csfic) return "pas de somme de contrle  la fin du fichier";
if (!feof($fp)) return "fichier incorrect : il y a du texte aprs la somme de contrle";
if ($csfic!=crc32($contenu)) return "somme de contrle incorrecte";
return "";
}

function enregistrer() {
global $etab_rne,$HIDEDATA;
$erreur="";
$copies="";
$infosfichier=_files('fichier');
//print_r($infosfichier);print "<br>";
$nom=strtolower($infosfichier['name']);
if (empty($nom)) erreur('Pas de fichier indiqu !');
$type=$infosfichier['type'];
$tmp_name=$infosfichier['tmp_name'];
$size=$infosfichier['size'];
$error=$infosfichier['error'];
if ($tmp_name=='none' || $size==0) erreur("Le fichier n'existe pas ou a une taille nulle ou trop importante.");
if ($error) erreur("Erreur $error pour $nom (tmp_name=$tmp_name)");
$dest="$HIDEDATA/sadmin";
creertousrep($dest);
if (!is_dir($dest)) erreur("Impossible de crer le rpertoire $dest.");
$dest.="/$nom";
if (!move_uploaded_file($tmp_name,$dest)) erreur("Erreur de copie vers $dest.");
return $dest;
}

function decompresser($nomfichier) {
global $etab_id, $etab_rne, $HIDEDATA;
if (ereg("\.(bz2|gz|sql)$" , $nomfichier, $cr)) {
    $restore="$HIDEDATA/$etab_rne/$etab_id".'_'.date('Ymd').'.sql';
    switch ($cr[1]) {
        case 'bz2':
             $fbz2=bzopen($nomfichier,'r');
             $fsql=fopen($restore,'w');
             while ($s=bzread($fbz2,10000)) fwrite($fsql,$s);
             fclose($fsql);
             bzclose($fbz2);
             break;
        case 'gz':
             $fgz=gzopen($nomfichier,'r');
             $fsql=fopen($restore,'w');
             while ($s=gzread($fgz,10000)) fwrite($fsql,$s);
             fclose($fsql);
             gzclose($fgz);
             break;
        case 'sql':
             $restore=$nomfichier;
             break;
    }
}
else $restore="";
return $restore;
}

//-------------  ppal  -------------------
opensession('Sadmin',false);
connecte($host,$user,$mdp,$db);
print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
print "<HTML><HEAD><link rel=\"stylesheet\" href=\"../include/general.css\">\n";
print "<title>Restauration de la base $db</title></head>\n";
print "<BODY class=\"arial_sadmin\">\n";
print "<p class='sous_titre'>Restauration complte de la base GiBii</p>\n";
if (!isset($bouton)) {
    choisir();
}
else {
    $nomrecu=enregistrer();
    if ($nomrestore=decompresser($nomrecu)) {
        $message=chksum_verif($nomrestore);
        if ($message)
            alert("Problme avec $nomrestore :\n$message");
        else {
            query("DROP DATABASE IF EXISTS $db;");
            query("CREATE DATABASE $db;");
            if (!SQL_execfile($nomrestore,$erreurs)) {
                print "<p>Erreurs : <br>";
                print_r($erreurs);
                print "</p>";
            }
            else print "Restauration effectue convenablement.";
        }
    }
    else alert("Le fichier fourni ($nomfichier)\nn'a pas l'extension voulue (sql, bz2 ou gz).");
}
print "</body></html>";

?>

